; Especificaciones: CIRCULOS para ZX Spectrum 16K/48K.
; Descripción general: Ejemplo del uso de CIRCLE en un bucle.
; Longitud: 52 bytes.
; Entrada: Ningún requerimiento.
; Salida: Circunferencias varias en memoria de pantalla.
; Registros usados: A, B y C en programa.
;                   A, B, C, D, E, H y L en rutina ROM.
; Nota importate: El registro doble alternativo H'L' debe ser
; guardado antes de ka llamada a la rutina CIRCLE, y restaurado
; antes del retorno al BASIC.
org		$7000

circle	equ $232d
cls		equ $0d6b
open	equ $1601
stack_a	equ $2d28

call	cls				; Borra la pantalla
ld		a, 2			; Abre
call	open			; canal 2
exx						; Set alternativo
push	hl				; Guarda H'L'
exx						; Set normal
ld		b, 0			; Variable, inicio = 0
OTRO:
push	bc				; Almacena variable
ld		a, b			; Pásala al acumulador
call	stack_a			; Almacena coordenada X
pop		bc				; Recupera variable
push	bc				; Almacena variable
ld		a, b			; Pásala al acumulador
call	stack_a			; Almacena coordenada Y
pop		bc				; Recupera variable
push	bc				; Almacena variable
ld		a, b			; Pásala al acumulador
call	stack_a			; Almacena radio
call	circle			; CIRCLE X,Y,RADIO
pop		bc				; Recupera variable
ld		a, 251			; Semifila Q-T
in		a, (254)		; Lee teclado
and		8				; ¿Tecla R pulsada?
jr		z, _RET			; Salta si está pulsada
inc		b				; B=B+1
ld		a, 87			; Valor máximo
cp		b				; Compara A-B
jr		nz, OTRO		; Si no es cero, sigue en bucle
_RET:
exx						; Set alternativo
pop		hl				; Recupera H'L'
exx						; Set normal
ret						; Vuelta al Basic

end		$7000